
| ---------------------------------------------------------------------------
| Sub PBPushCallStack
| Helper for debugging. Records current sub so next sub can read it.
| Usage: /call PBPushCallStack CURRENTSUB
| ---------------------------------------------------------------------------
	Sub PBPushCallStack(string SubName)
		/if (!${Defined[PBCallStack]}) {
			| If 100 isn't enough something is probably wrong. Allows for some slop.
			/declare PBCallStack[100,1]	string	outer	null
			/declare PBCallStackIndex		int		outer	0
		}
		/if (${PBCallStackIndex}==100) {
			/echo CallStack ${SubName} exceeds max stack size 100. Dumping stack and quitting.
			/declare i int local 0
			/for i 1 to 100
				/echo ${i} ${PBCallStack[${i},1]}
			/next i
			/endmacro
		}
		/varcalc PBCallStackIndex ${PBCallStackIndex}+1
		/varset PBCallStack[${PBCallStackIndex},1] ${SubName}
	/return
	
| ---------------------------------------------------------------------------
| Sub PBPopCallStack
| Helper for debugging. Removes the sub from the stack.
| Usage: /call PBPopCallStack
| ---------------------------------------------------------------------------
	Sub PBPopCallStack(int CallIndex)
		/while (${CallIndex}>${PBCallStackIndex})
			/varset PBCallStack[${PBCallStackIndex},1] NULL
			/varcalc PBCallStackIndex ${PBCallStackIndex}-1
		}
	/return
	
| ---------------------------------------------------------------------------
| Sub PBGetCall
| Helper for debugging. Retrieves the top call from the stack (will be previous sub)
| ---------------------------------------------------------------------------
	Sub PBGetCall
	/return ${PBCallStack[${PBCallStackIndex},1]}
	
| ---------------------------------------------------------------------------
| Sub Bind_PBCallStack
| Helper for debugging. Records current sub so next sub can read it.
| Usage: /pbcallstack
| ---------------------------------------------------------------------------
	Sub Bind_PBCallStack
		/if (!${Defined[PBCallStack]}) {
			/echo No stack to check.
			/return
		}
		/echo CallStack size ${PBCallStackIndex}.
		/declare i int local 0
		/for i 1 to ${PBCallStackIndex}
			/echo ${i} ${PBCallStack[${i},1]}
		/next i
	/return

|-----------------------------------------------------------------------------
| SUB:Bind_PBDebug
|
| From KA12 and modified. This whole debug thing is ugly. Needs redo.
| ----------------------------------------------------------------------------
    Sub Bind_PBDebug(string p_cmd1, string p_cmd2, string p_cmd3)

        /declare str_onoff 		string 	local
        /declare str_command 	string 	local
        /declare str_uselog 	string 	local
		
        /if (${EverQuest.CurrentUI.NotEqual[Default]}) {
            /echo You are using a Custom UI. Please switch to Default UI before Posting.
        }
		
        | Check param 3
        /if (${Select[${p_cmd3},log,logc]}) {
            /varset str_uselog ${Select[${p_cmd3},log,logc]}
        } else {
            /varset str_uselog 0
        }
		
        | Check Param 2
        /if (${Select[${p_cmd2},0,1,on,off]}) {
            /varset str_command ${p_cmd1}
            /varset str_onoff ${p_cmd2}
            /if (${p_cmd2.Equal[on]}) {
                /varset str_onoff 1
            } else {
                /varset str_onoff 0
            }
        } else /if (${Select[${p_cmd2},log,logc]}) {
            /varset str_uselog ${Select[${p_cmd2},log,logc]}
            /varset str_onoff
        } else {
            /varset str_onoff
        }
		
        | Check Param 1
        /if (${Select[${p_cmd1},0,1,on,off]}) {
            /varset str_command Debug
            /varset str_onoff ${p_cmd1}
            /if (${p_cmd1.Equal[on]}) {
                /varset str_onoff 1
            } else {
                /varset str_onoff 0
            }
            /if (!${str_onoff} && ${PBDebugAllOn}) /varset str_command all
        } else /if (${p_cmd1.Equal[all]}) {
            /varset str_command ${p_cmd1}
		|
		| All Debug vars must have *only* the first letter capitalized. E.g. HealSingle won't be found but Healsingle will.
		|
        } else /if (${Select[${p_cmd1},${PBDebugSectionList}]}) {
            /varset p_cmd1 ${p_cmd1.Left[1].Upper}${p_cmd1.Right[-1].Lower}
            /varset str_command PBDebug${p_cmd1}
        } else /if (!${p_cmd1.Length}) {
            /if (${PBDebugAllOn}) {
                /varset str_command all
            } else {
                /varset str_command PBDebug
            }
        } else {
            /varset str_command Help
            /varset str_onoff
        }
		
        /if (${str_command.Equal[help]}) {
            /echo --------------------------------------------------------------------------------------------
            /echo \ayDebug help: 
            /echo \ay    /pbdebug command action1 action2
            /echo \ay        command: \ao${PBDebugSectionList}
            /echo \ay        action1: \aoon/off/0/1 or blank 
            /echo \ay        action2: \aolog or blank
            /echo \ag    Examples:
            /echo \at        /pbdebug all on -----> Turns on all debug sections.
            /echo \at        /pbdebug all off ----> Turns off all debug sections.
            /echo \at        /pbdebug all --------> Toggles debug all.
            /echo \at        /pbdebug all log ----> Toggles debug all and starts/stops logging.
            /echo \at        /pbdebug hunt on ----> Turns on hunt debug section.
            /echo \at        
            /echo \at        /pbdebug log - Is an invalid format and shouldn't be used. 
            /echo 
            /echo \ay        log - can be used as either action1 or action2, but never as command.
            /echo \ay              you do NOT have to sepcify the log action to turn logging off.
            /echo \ay              any action that turns off any debug command will stop logging.
            /echo
            /echo \ay    Note: MQ2Log plugin will be loaded using the noauto option if the plugin is not loaded. 
            /echo --------------------------------------------------------------------------------------------
            /return
			
        } else /if (${str_command.Equal[debug]}) {
            /if (!${str_onoff.Length}) {
                /if (${PBDebug}) {
                    /varset str_onoff 0
                } else {
                    /varset str_onoff 1
                }
            }
            /varset PBDebug ${str_onoff}
            /if (${PBDebug}) {
                /echo \atDEBUG On
            } else {
                /echo \atDEBUG Off
            }
        } else /if (${str_command.Equal[all]}) {
            /if (!${str_onoff.Length}) {
                /if (${PBDebugAllOn}) {
                    /varset str_onoff 0
                } else {
                    /varset str_onoff 1
                }
            }
            /varset PBDebugAllOn ${str_onoff}
            /if (${PBDebugAllOn}) {
                /echo \atDebugAll On
            } else {
                /echo \atDebugAll Off
            }
            /varset PBDebug ${PBDebugAllOn}
            /varset PBDebugHunt ${PBDebugAllOn}			
            /varset PBDebugInit ${PBDebugAllOn}
            /varset PBDebugMain ${PBDebugAllOn}
            /varset PBDebugTarget ${PBDebugAllOn}
        } else /if (${Defined[${str_command}]}) {
            /if (!${str_onoff.Length}) {
                | Double brackets it is on purpose.
                /if (${${str_command}}) {
                    /varset str_onoff 0
                } else {
                    /varset str_onoff 1
                }
            }
            /varset ${str_command} ${str_onoff}
            /if (${${str_command}}) {
                /echo \at${str_command} On
            } else {
                /echo \at${str_command} Off
            }
        } else {
            /echo Invalid Command. Try /pbdebug help.
            /return
        }
		
        /if (${str_uselog}) {
            /if (!${Bool[${Plugin[mq2log]}]}) {
                /plugin MQ2Log noauto 
                /delay 20 ${Bool[${Plugin[mq2log]}]}==True
            }
            /if (!${PBDebugLogging}) {
                /if (${str_onoff.Equal[1]}) {
                    /if (${str_uselog.Equal[2]}) /mqlogcustom PetBot_${Me.CleanName} clear
                    /mlog on
                    /varset PBDebugLogging 1
                    /echo Using UI: ${EverQuest.CurrentUI}
                    /call PBSettings
                    /plugin list
                }
            } else {
                /if (${str_onoff.Equal[0]}) {
                    /echo PetBot Debug Off!
                }
            }
        } else {
            /if (${PBDebugLogging}) {
                /if (${str_onoff.Equal[0]}) {
                    /echo PetBot Debug Off!
                }
            }
        }
    /return
	
