
| -----------------------------------------------------------------------------
| Sub:PBFindAMobToSic
| -----------------------------------------------------------------------------
	Sub PBFindAMobToSic
	
		| Debug call stack
		PBCALLINGSUB
		PBCALLINGINDEX
		PBPUSHCALL
	
		/declare PBNearestMobID		int		local	0
		/declare PBSelectedMobID	int		local	0
		/declare i					int		local	0
		/declare PBNumMobs			int		local	0
	
		| This is a Red Pill situation. I can lift my code from KA to bulletproof if I'm inclined.
		/if (!${Me.CombatState.Equal[combat]}) {
			| Find something to kill. Note that non-hostile npcs will also be attacked. Check nearest 10 mobs.

			/varset PBNumMobs ${SpawnCount[npc targetable radius ${PBPetAttackDist} zradius 50]}

			/for i 1 to ${PBNumMobs}
				/varset PBNearestMobID ${NearestSpawn[${i},npc targetable radius ${PBPetAttackDist} zradius 50].ID}

				/call PBIsGoodTargetType ${Spawn[id ${PBNearestMobID}].Type}
				/if (${Macro.Return.Equal[0]}) /continue
				
				/call PBIsFriendly ${PBNearestMobID}
				/if (!${Macro.Return.Equal[MAY-BE-HOSTILE]}) /continue

				/if (${PBPetUseLOS}) {
					/if (!${Spawn[id ${PBNearestMobID}].LineOfSight}) /continue
				}

				| On ignore list?
				/if (${PBUseIgnoreListOn}) {
					/if (${PBZoneIgnoreList.Find[|${Spawn[id ${PBNearestMobID}].CleanName}|]}) {
						/continue
					}
				}
				
				| On attack list?
				/if (${PBUseAttackListOn}) {
					/if (${PBZoneAttackList.Find[|${Spawn[id ${PBNearestMobID}].CleanName}|]}) {
						| Is someone else attacking it?
						/if (${Spawn[id ${PBNearestMobID}].PctHPs}<100) {
							/call OnXTarget ${PBNearestMobID}
							| If the wounded target is not on my aggro, we skip.
							/if (${Macro.Return.Equal[0]}) {
								/continue
							}
						}
						/varset PBSelectedMobID ${PBNearestMobID}
						/break
					}
				}
				
				/if (${PBPetMode.Equal[bite]}) {
					| Validate mob
					/varset PBSelectedMobID ${PBNearestMobID}
					/break
				}
				
			/next i
			
		} else /if (${Me.XTarget[${PBXTSlot}].ID}) {
			/varset PBSelectedMobID ${Me.XTarget[1].ID}
		}

		PBPOPCALL

	/return ${PBSelectedMobID}

| -------------------------------------------------------------------------------------
| Sub:PBRadarAtMob
|
| Results from PBRadarAtLoc:
| ${PBNumValidMobs}|${PBNearestValidMobID}|${PBNumMobs}|${PBNearestMobID}|${PBHighestLevel}
|
| There will always be at least 1 mob, the mob itself.
| -------------------------------------------------------------------------------------
	Sub PBRadarAtMob(int MobID, int PBRadius)

		/call PBRadarAtLoc ${Spawn[id ${MobID}].X} ${Spawn[id ${MobID}].Y} ${Spawn[id ${MobID}].Z} ${PBRadius}

	/return ${Macro.Return}

| -------------------------------------------------------------------------------------
|   Sub PBRadarAtLoc
| -------------------------------------------------------------------------------------
    Sub PBRadarAtLoc(int PBDX, int PBDY, int PBDZ, PBDRadius)
				
		| Get all the mobs and let EvaluateTarget sort it out
		/declare PBNumMobs				int		local	${SpawnCount[loc ${PBDX} ${PBDY} ${PBDZ} npc targetable radius ${PBDRadius} zradius 50]}
		/declare PBNearestMobID			int		local 	${NearestSpawn[1,loc ${PBDX} ${PBDY} ${PBDZ} npc targetable radius ${PBDRadius} zradius 50].ID}

		/declare PBMobID				int		local	0
		/declare PBNumValidMobs			int		local	0
		/declare i						int		local	0
		/declare PBResults				string	local
		/declare PBNearestValidMobID	string	local	0
		/declare PBEvaluateReturn		string	local
		/declare PBMobLevel				int		local	0
		/declare PBHighestLevel			int		local	0
		
        /if (${PBNumMobs}>0) {
            /for i 1 to ${PBNumMobs}
                /varset PBMobID ${NearestSpawn[${i},loc ${PBDX} ${PBDY} ${PBDZ} npc targetable radius ${PBDRadius} zradius 50].ID}
				/varset PBMobLevel ${Spawn[id ${PBMobID}].Level}
				/if (${PBMobLevel}>${PBHighestLevel}) /varset PBHighestLevel ${PBMobLevel}
                /if (${PBMobID}) {
					/call PBEvaluateTarget ${PBMobID}
					/varset PBEvaluateReturn ${Macro.Return}
					/if (${PBEvaluateReturn.Equal[1]})
						/if (!${PBNearestValidMobID}) /varset PBNearestValidMobID ${PBMobID}
						/varcalc PBNumValidMobs ${PBNumValidMobs}+1
					}
				}
            /next i
		}
	
		/varset PBResults ${PBNumValidMobs}|${PBNearestValidMobID}|${PBNumMobs}|${PBNearestMobID}|${PBHighestLevel}

    /return ${PBResults}
	
| -----------------------------------------------------------------------------
| Sub:PBEvaluateTarget
| -----------------------------------------------------------------------------
	Sub PBEvaluateTarget(int PBMobID)

		/declare MobOk		int		local	0
		/declare MobName	string	local	${Spawn[id ${PBMobID}].CleanName}

		| Is it the right level?
		/call PBIsRightLevel ${PBMobID}
		/if (${Macro.Return.Equal[0]}) /return BADLEVEL

		| Is it friendly?
		/call PBIsFriendly ${PBMobID}
		/if (${Macro.Return.NotEqual[MAY-BE-HOSTILE]}) /return FRIENDLY

		| Is the mob on the ignore list?
		/if (${PBUseIgnoreList}) {
			| Is the mob being ignored?
			/call PBIsIgnore "${MobName}"
			/if (${Macro.Return.Equal[1]}) /return IGNORED
		}
		
		| Is the mob on the kill list?
		/if (${PBUseAttackList}) {
			| Is the mob kos?
			/call PBIsAttack "${MobName}"
			/if (${Macro.Return.Equal[1]}) /return 1
		}
		
		| Let's consider it
		/if (${PBAutoConsiderOn}) {
			/consider
			/delay 1s
			/doevent PBConsider
			/if (${Macro.Return.Equal[HOSTILE]}) {
				/call Bind_PBAddKOS "${MobName}"
			} else {
				/call Bind_PBAddIgnore "${MobName}"
				/return NOT-HOSTILE
			}
		}		
	
	/return 1
	
| -----------------------------------------------------------------------------
| Sub:PBHunt
| -----------------------------------------------------------------------------
	Sub PBHunt

		| Debug call stack
		PBCALLINGSUB
		PBCALLINGINDEX
		PBPUSHCALL

		PBDEBUGHUNT Entered

		/declare PBSelectedMobID	int		local		0

		/while (!${Me.Hovering} && ${Me.Pet.ID} && !${PBisDMZ} && !${PBPauseOn}) {
			
			PBDEBUGHUNT In the main Hunt loop
			
			| For now, do this.
			/if (${Pet.Combat}) /continue
			/if (${Me.Invis}) /continue
			/if (${Me.PctHPs}<80) /continue
			/if (${Me.PctMana}<80) /continue

			PBDEBUGHUNT Looking for a mob

			/call PBFindAMobToSic
			/varset PBSelectedMobID ${Macro.Return}

			| If we found a valid mob, and we are not invisible, let's sic'em
			/if (${PBSelectedMobID}) {
			
				PBDEBUGHUNT Found mob ${Spawn[id ${PBSelectedMobID}].CleanName} (${PBSelectedMobID})
			
				| Only issue /target command if it's not already your target.
				/if (${Target.ID} != ${PBSelectedMobID}) {
					/target id ${PBSelectedMobID}
					/delay 2s ${Target.ID}==${PBSelectedMobID}
				}
				
				/if (${Target.ID}==${PBSelectedMobID}) {
					PBDEBUGHUNT Attacking the mob
					/pet taunt on
					/pet hold on
					/pet ghold on
					/pet attack
					/pet swarm
					/delay 1s
				} else {
					/continue
				}

				| Sometimes pets cant start the fight, like destructible objects.
				/if (!${Pet.Target.ID} && ${Spawn[id ${PBSelectedMobID}].ID}) {
					/call Bind_PBAddToIgnoreList "${Spawn[id ${PBSelectedMobID}].CleanName}"
					/continue
				}

				PBDEBUGHUNT Top of Kill loop
				| Kill! Loop
				/while (${Pet.Target.ID}) {

					PBDEBUGHUNT In the kill loop

					| If we move out of range while pet was sent to attack, come back before we hit it.
					/if (${Spawn[id ${PBSelectedMobID}].Distance}>${PBPetAttackDist} && ${Spawn[id ${PBSelectedMobID}].PctHPs}==100) {
						/pet back off
						PBDEBUGHUNT Mob out of range, pulling back.
						/break
					}

					/if (!${Me.Pet.ID}) {
						/echo Your pet died a noble death. /sad Oh. here comes the mob. Runaway!
						PBDEBUGHUNT My pet died. Returning to main loop.
						/return PETDIED
					}
					
					/if (!${Spawn[id ${PBSelectedMobID}].ID} || ${Spawn[id ${PBSelectedMobID}].Type.Equal[Corpse]}) {
						| If still fighting, leave him in the loop, otherwise, exit
						/if (!${Pet.Combat}) {
							PBDEBUGHUNT Combat over with the selected mob.
							/break
						}
					}
					
					/delay 1s
				}
				
				PBDEBUGHUNT Bottom of the kill loop
				
				| Combat over. Recovery time.
				/if (${PBVerbose}) {
					/echo Pausing ${PBPetAttackDly} before next mob.
				}
				PBDEBUGHUNT Pausing before next
				/call PBDelay ${PBPetAttackDly}
			}
			
			PBDEBUGHUNT Bottom of main loop
			
			/delay 1s
		}
		
		| Drop from the Hunt loop if we died, pet died, or entered a DMZ

		/if (${Me.Hovering}) {
			/if (${PBVerbose}) {
				/echo You have died a glorious death.
			}
		} else /if (!${Me.Pet.ID}) {
			/if (${PBVerbose}) {
				/echo Your pet is no more.
			}
		}
		
		/if (${PBisDMZ}) {
			/if (${PBVerbose}) {
				/echo You have entered a safe zone.
			}
		}
		
		PBDEBUGHUNT Exited main hunt loop
		
		PBPOPCALL
		
	/return
