
| ----------------------------------------------------------------------------
| SUB: Event PBGetLooseMobHelp
| Rush to the aid of the character to get mob off them.
| ----------------------------------------------------------------------------
	Sub Event_PBGetLooseMobHelp(Message,AttackingMobName,AttackingMobID,CharName,CharID)

		| Debug call stack
		PBCALLINGSUB
		PBCALLINGINDEX
		PBPUSHCALL

		/doevents flush PBGetLooseMobHelp
		|
		| Catch so broadcast doesn't trigger unnecessarily
		|
		/if (${Me.ID}==${CharID}) {
			PBPOPCALL
			/return
		}
		/call PBGetTheLooseMob "${AttackingMobName}" ${AttackingMobID} ${CharName} ${CharID}
		
		PBPOPCALL
	/return

| ----------------------------------------------------------------------------
| Sub:Event_PBGetLooseMob
| Deal with loose mob.
| ----------------------------------------------------------------------------
	Sub Event_PBGetLooseMob(Message,AttackingMobName,AttackingMobID)
		| Debug call stack
		PBCALLINGSUB
		PBCALLINGINDEX
		PBPUSHCALL

		/doevents flush PBGetLooseMob
		/call PBGetTheLooseMob "${AttackingMobName}" ${AttackingMobID} NULL 0
		PBPOPCALL
	/return
	
| ---------------------------------------------------------------------------
| Sub:PBGetTheLooseMob
| ---------------------------------------------------------------------------
	Sub PBGetTheLooseMob(AttackingMobName,AttackingMobID,CharName,CharID)
		/if (!${RescueCharsOn}) /return
		/if (!${AttackingMobID}) /return

		| Debug call stack
		PBCALLINGSUB
		PBCALLINGINDEX
		PBPUSHCALL
	
		/declare GetTheLooseMobTimerSec	int		local	30
		/declare PreviousTargetID 		int		local	${Target.ID}
		/if (!${GetTheLooseMobAlertOn} && ${Target.Named} && ${Select[${Role},tank,pullertank,pettank,pullerpettank,hunter,hunterpettank]}) {
			/echo I'm busy tanking named ${MyTargetName} (${MyTargetID})
			/varset GetTheLooseMobAlertOn ${GetTheLooseMobTimerSec}s
			PBPOPCALL
			/return
		}
		/call TargetThis ${AttackingMobID}
		/if (!${Target.ID}) {
			/if (${PreviousTargetID}) /call TargetThis ${PreviousTargetID}
			PBPOPCALL
			/return
		}
		/call LastMove
		/if (!${GetTheLooseMobAlertOn} && ${Target.ID}!=${AttackingMobID}) {
			/call BroadCast y "Engaging loose mob ${AttackingMobName} (${AttackingMobID})"
			/varset GetTheLooseMobAlertOn ${GetTheLooseMobTimerSec}s
		}
		/if (!${Target.Mezzed.ID} && ${Me.Pet.ID}) {
			/call PetTauntSwitch 1
			/call PetEngageTarget ${AttackingMobID} 1
		}

		| Anyone that can debuff or do something/slow needs to step up here
		/call PBMitigateAggro ${AttackingMobID}

		|
		| Can I tank or have a pet to distract with?
		|
		/if (!${Target.Mezzed.ID} && (!${Select[${Role},tank,offtank,pullertank,pettank,petofftank,pullerpettank,hunter,hunterpettank]} || !${Me.Pet.ID})) {
			POPCALL
			/return
		}
		PBPOPCALL
	/return

| ----------------------------------------------------------------------------
| Sub:PBGotHit
| ----------------------------------------------------------------------------
    Sub Event_PBGotHit(string Line, string AttackingMob)
        /doevents flush PBGotHit

		| Debug call stack
		PBCALLINGSUB
		PBCALLINGINDEX
		PBPUSHCALL

        /varset PBEventFlag 1
        /declare GotHitDistChk int local 15
        /declare AttackingMobID		int		local	0

		/call LastMove
		|
		| It seems that items on the cursor or the give window being open don't affect combat.
		|
        |/if (${Window[GiveWnd].Open}) {
        |    /invoke ${Window[GiveWnd].DoClose}
        |}
		|/call CheckCursor Event_GotHit 1
		
        /if (${Window[LootWnd].Open}) /invoke ${Window[LootWnd].DoClose}
		/if (${Window[SpellBookWnd].Open}) /invoke ${Window[SpellBookWnd].DoClose}
					
		/call PBTargetSet
		/pause 5
		/if (!${Target.ID}) {
			/varset AttackingMobID ${NearestSpawn[1,npc radius 39 "${AttackingMob}"].ID}
		} else {
			/varset AttackingMobID ${Target.ID}
		}
		/call PBTargetThis ${AttackingMobID}		
		
        |- If mob that hit me still too close, move to camp or away from mob.
        /if (${AttackingMobID}) {
            /echo I got hit by >>${AttackingMob}<< ID:${AttackingMobID}!
					
            | If mob is in pet attack range from camp, send pet in.
			/if (${Me.Pet.ID}) /call PetEngageTarget ${AttackingMobID} 1
                    
			|- Only move away from mob if MoveWhenHit enabled (1)
            /if (${Math.Distance[${Me.Y},${Me.X}:${CampYLoc},${CampXLoc}]}>${CampRadius} && !${Select[${Role},hunterpettank]}) {
                |- Only move away from mob if MoveWhenHit enabled (1)
                /if (${MoveWhenHit} || ${ReturnToCamp}) {
                    /echo Moving back to camp!
					/call DoWeMove 1 Bind_CampFire							
                }
            } else /if (${MoveWhenHit}) {
	            /moveto dist ${GotHitDistChk}
			}
        }
        |/if (${MoveWhenHit}) /delay 15 ${Math.Distance[${Me.Y},${Me.X}:${Target.Y},${Target.X}]}>${GotHitDistChk}
        /if (${FaceMobOn} && ${Target.ID}) /face ${If[${FaceMobOn}==2,nolook,fast nolook]}
        /look 0
		
		|
		| Should I be getting hit? If not, then say something. We can't have the character wrangling the super important pet or healers die.
		| First check the role. Then check the class. If they are softies, then have them broadcast. Rangers especially.
		|
		/if (${AttackingMobID} && ${Select[${Role},assist,petassist,pettank,petofftank,pullerpettank,hunterpettank,puller]}) {
			/if (!${Select[${Me.Class.ShortName},WAR,SHD,PAL]}) {
				/call BroadCast y "Help! Mob >>${AttackingMob}<< (${AttackingMobID}) attacking me (${Me.Name}:${Me.ID})!"
			}

			| Slow attacks
			/varcalc DPSRateDelay ${DPSRateDelay}+${DPSRateReduction}

			| Try to do something constructive about my predicament.
			/call MitigateAggro ${AttackingMobID} GotHit
		}
        /varset GotHitToggle 0
		POPCALL
    /return
