
| ---------------------------------------------------------------------------
| SUB:PBLastMove
| 
| Time since character last moved accessible in TimeSinceMove in tenths of a sec
| ---------------------------------------------------------------------------
	Sub PBLastMove

		| We want to know how long since the player has done anything with the character...
		|/if (${Me.X}!=${PBLastMoveX} || ${Me.Y}!=${PBLastMoveY} || ${Me.Z}!=${PBLastMoveZ} || ${Me.Heading.Degrees}!=${PBLastMoveHeading} || ${Me.Combat} || ${Me.CombatState.Equal[COMBAT]} || ${Me.Sitting}!=${PBLastSitStand}) {	
		/if (${Me.X}!=${PBLastMoveX} || ${Me.Y}!=${PBLastMoveY} || ${Me.Z}!=${PBLastMoveZ} || ${Me.Heading.Degrees}!=${PBLastMoveHeading} || ${Me.Sitting}!=${PBLastSitStand}) {
			/varset PBLastMoveTime ${EverQuest.Running}
			/varset PBLastMoveX 		${Me.X}
			/varset PBLastMoveY 		${Me.Y}
			/varset PBLastMoveZ 		${Me.Z}
			/varset PBLastMoveHeading ${Me.Heading.Degrees}
			/varset PBLastSitStand	${Me.Sitting}
			/varset PBTimeSinceMove 0
		} else {
			/varcalc PBTimeSinceMove (${EverQuest.Running}-${PBLastMoveTime})/1000
		}
		| Give 60 seconds when first starting
		/if (${Math.Calc[(${EverQuest.Running}-${PBBootTime})/1000]}<60) /varset PBTimeSinceMove 60

	/return

| ---------------------------------------------------------------------------
| Sub:PBOnXTarget
|
| If given an id, tell whether it's on xtarget. If no id is given, it returns
| whether anything is on xtarget.
| ---------------------------------------------------------------------------
	Sub OnXTarget(int MobID)
	/return (${Select[${MobID},${Me.XTarget[1].ID},${Me.XTarget[2].ID},${Me.XTarget[3].ID},${Me.XTarget[4].ID},${Me.XTarget[5].ID},${Me.XTarget[6].ID},${Me.XTarget[7].ID},${Me.XTarget[8].ID},${Me.XTarget[9].ID},${Me.XTarget[10].ID},${Me.XTarget[11].ID},${Me.XTarget[12].ID},${Me.XTarget[13].ID}]}==0)
		
| -----------------------------------------------------------------------------
| Sub:PBIsIgnore
| -----------------------------------------------------------------------------
	Sub PBIsIgnore(string MobCleanName)	
	/return ${If[${PBZoneIgnoreList.Find[|${MobCleanName}|]},1,0}

| -----------------------------------------------------------------------------
| Sub:PBIsAttack
| -----------------------------------------------------------------------------
	Sub PBIsAttack(string MobCleanName)	
	/return ${If[${PBZoneAttackList.Find[|${MobCleanName}|]},1,0}

| -----------------------------------------------------------------------------
| Sub:PBIsRightLevel
| -----------------------------------------------------------------------------
	Sub PBIsRightLevel(int MobID)
	/return ${If[(${Spawn[id ${MobID}].Level}>=${PBLowestLevel} && ${Spawn[id ${MobID}].Level}<=${PBHighestLevel}),1,0]}

| -----------------------------------------------------------------------------
| Sub:PBIsFriendly
| -----------------------------------------------------------------------------
	Sub PBIsFriendly(int SpawnID)
	
		| Debug call stack
		PBCALLINGSUB
		PBCALLINGINDEX
		PBPUSHCALL
	
		/declare 	j 					int 	local	0
		/declare 	MobID 				int 	local 	0
		/declare 	MobMasterID 		int 	local 	0
		/declare	MobTarget			string	local

		/if (${SpawnID}) {
			|/varset MobTarget ${Spawn[id ${SpawnID}].DoTarget}
			|/delay 5
			/varset MobID ${Spawn[id ${SpawnID}].ID}
			/varset MobMasterID ${Spawn[id ${SpawnID}].Master.ID}
		} else {
		   /varset MobID ${Target.ID}
		   /varset MobMasterID ${Target.Master.ID}
		}
		
		/if (!${MobID}) /return NO-SPAWN
		/if (${Spawn[id ${MobID}].Type.Equal[CORPSE]}) /return DEAD-SPAWN

		| Are we looking at anything that is me?
		/if (${MobMasterID}==${Me.ID}) /return FRIENDLY
		/if (${MobID}==${Me.ID}) /return FRIENDLY
		/if (${MobID}==${Me.Mercenary.ID}) /return FRIENDLY
		/if (${MobID}==${Me.Pet.ID}) /return FRIENDLY
		/if (${MobID}==${Me.Mount.ID}) /return FRIENDLY
		
		/if (${Spawn[id ${MobID} group].ID}>0) /return FRIENDLY
		
		/if (${MobMasterID}) {
			/for j 1 to ${Group.Members}
				/if (${MobMasterID}==${Group.Member[${j}].ID}) /return FRIENDLY
				/if (${MobMasterID}==${Group.Member[${j}].Master.ID}) /return FRIENDLY
				/if (${MobMasterID}==${Group.Member[${j}].Pet.ID}) /return FRIENDLY
			/next j
		}

		PBPOPCALL

	/return MAY-BE-HOSTILE

| -----------------------------------------------------------------------------
| Sub:Event_PBConsider
| -----------------------------------------------------------------------------
	Sub Event_PBConsider(Message,string FromWho,string FactionStr)
		/doevents flush PBConsider

		|	" scowls at you."
		|	" glares at you threateningly."
		|	" glowers at you dubiously."
		|	" looks your way apprehensively."
		|	" regards you indifferently."
		|	" judges you amiably."
		|	" kindly considers you."
		|	" looks upon you warmly."
		|	" regards you as an ally."
		
		if (${FactionStr.Equal[scowls]}) {
			/varset LookingAtMe_ThreatLevel 1
		} else /if (${FactionStr.Equal[threateningly]}) {
			/varset LookingAtMe_ThreatLevel 2
		} else /if (${FactionStr.Equal[dubiously]}) {
			/varset LookingAtMe_ThreatLevel 3
		} else /if (${FactionStr.Equal[apprehensively]}) {
			/varset LookingAtMe_ThreatLevel 4
		} else /if (${FactionStr.Equal[indifferently]}) {
			/varset LookingAtMe_ThreatLevel 5
		} else /if (${FactionStr.Equal[amiably]}) {
			/varset LookingAtMe_ThreatLevel 6
		} else /if (${FactionStr.Equal[kindly]}) {
			/varset LookingAtMe_ThreatLevel 7
		} else /if (${FactionStr.Equal[warmly]}) {
			/varset LookingAtMe_ThreatLevel 8
		} else /if (${FactionStr.Equal[ally]}) {
			/varset LookingAtMe_ThreatLevel 9
		}
		
		/if (${Select[${LookingAtMe_ThreatLevel},1,2]}) /return HOSTILE
		/if (${Select[${LookingAtMe_ThreatLevel},3,4]}) /return MAYBE_HOSTILE
		
	/return NOT_HOSTILE

| -----------------------------------------------------------------------------
| Sub:PBStripExtraPipes
| You must enclose your string in quotes if there are spaces "String goes here"
| -----------------------------------------------------------------------------
	Sub PBStripExtraPipes(string StringParam)
		/while (${StringParam.Find[||]}) {
			/varset StringParam ${StringParam.Replace[||,|]}
		}
		
	/return ${StringParam}

| -----------------------------------------------------------------------------
| Sub:PBStripQuotes
| -----------------------------------------------------------------------------
	Sub PBStripQuotes(string StringParam)		
	/return ${StringParam.Replace[",]}

| -----------------------------------------------------------------------------
| Sub:PBUCase
| Capitalize first letter
| -----------------------------------------------------------------------------
	Sub PBUCase(string TheString)
	
		/varset TheString ${TheString.Lower}
		/declare TheStringFirstLetter	string	local ${TheString.Left[1]}
		/declare TheRestOfTheString		string	local ${TheString.Right[-1]}
		/varset TheString ${TheStringFirstLetter.Upper}${TheRestOfTheString}

	/return ${TheString}

| ---------------------------------------------------------------------------
| Sub:PBSetTheTarget
|
| Validates the target and sets PBTargetID and PBTargetName. Accepts id or name.
| ---------------------------------------------------------------------------
	Sub PBSetTheTarget(string IntendedTarget)
		| Debug call stack
		PBCALLINGSUB
		PBCALLINGINDEX
		
		PBDEBUGTARGET Enter - IntendedTarget ${IntendedTarget} for PBTarget
		
		/declare IntendedTargetID		int		local 	${Int[${IntendedTarget}]}
		/declare IntendedTargetName 	string 	local 	${IntendedTarget}
		/declare IntendedTargetResultID	int		local	0		
		/declare IntendedTargetResult	string	local
		
		/if (${IntendedTargetName.NotEqual[NULL]} && ${IntendedTargetName.Length}) {
			|
			| Is it real?
			|
			/if (${IntendedTargetID}) {
				/if (${Spawn[id ${IntendedTargetID}].ID}) {
					/varset IntendedTargetResultID ${Spawn[id ${IntendedTargetID}].ID}
				}
			} else /if (${IntendedTargetName.Length}) {
				/varset IntendedTargetResultID ${Spawn[=${IntendedTargetName}].ID}
			}
			
			|
			| If something was specified, but we didn't find it, leave the current target information alone.
			|
			/if (!${IntendedTargetResultID}) {
				PBDEBUGTARGET Leave - Couldnt find IntendedTarget ${IntendedTarget}
				/return
			}
		
			/varset PBTargetID ${IntendedTargetResultID}
			/varset PBTargetName ${Spawn[id ${IntendedTargetResultID}].CleanName}
		} else {
			|
			| If nothing was specified, clear the target information.
			|
			/varset PBTargetID 0
			/varset PBTargetName
		}
		PBDEBUGTARGET Leave - IntendedTarget ${IntendedTarget} PBTargetID ${PBTargetID} PBTargetName ${PBTargetName}
	/return
	
| -------------------------------------------------------------------------------------
| Sub:PBTargetSet
|
| Generic Target function.  Accepts a name or id.
| -------------------------------------------------------------------------------------
	Sub PBTargetSet(string IntendedTarget)
		| Debug call stack
		PBCALLINGSUB
		PBCALLINGINDEX
		PBPUSHCALL
		
		PBDEBUGTARGET Enter - IntendedTarget ${IntendedTarget} for PBTarget
		|
		| Clear the target if nothing was provided.
		|		
		/if (${IntendedTarget.Equal[NULL]} || !${IntendedTarget.Length}) {
			/squelch /target clear
			/varset PBTargetID 0
			/varset PBTargetName
			PBDEBUGTARGET Leave - Clearing Target and PBTarget
			PBPOPCALL
			/return
		}
		
		/call PBSetTheTarget "${IntendedTarget}"
		/call PBTargetThis ${PBTargetID}
		PBPOPCALL
		PBDEBUGTARGET Leave - IntendedTarget ${IntendedTarget} Target ID ${Target.ID} PBTargetID ${PBTargetID} PBTargetName ${PBTargetName}
	/return
	
| -------------------------------------------------------------------------------------
| Sub:PBTargetThis
|
| Generic Target function. Accepts only id.
| -------------------------------------------------------------------------------------
	Sub PBTargetThis(int IntendedTargetID)
		| Debug call stack
		PBCALLINGSUB
		PBCALLINGINDEX
		
		PBDEBUGTARGET Enter - IntendedTargetID ${IntendedTargetID}
		|
		| Clear the target if nothing was provided.
		|		
		/if (!${IntendedTargetID}) {
			/squelch /target clear
			/varset PBTargetID 0
			/varset PBTargetName
			PBDEBUGTARGET Leave - Clearing Target
			/return
		}
		
		/if (${Target.ID}==${IntendedTargetID}) {
			PBDEBUGTARGET Leave - Same Target
			/return
		}
		
		|
		| I believe that changing the target before buffs populated is a red flag.
		|
		/squelch /target id ${IntendedTargetID}
		/delay 20 ${Target.ID}==${IntendedTargetID} && ${Target.BuffsPopulated}
		
		PBDEBUGTARGET Leave - IntendedTargetID ${IntendedTargetID} Target ID ${Target.ID}
	/return
	
| -----------------------------------------------------------------------------
| Sub:PBIsGoodTargetType
| -----------------------------------------------------------------------------
	Sub PBIsGoodTargetType(string MobType)
	/return ${If[${Select[${MobType},AURA,BANNER,CAMPFIRE,CORPSE,CHEST,ITEM,TRIGGER,TRAP,TIMER,MOUNT,Mercenary]},0,1]}
